/*

     Guaranteed cost H2 output feedback control problem
     Cross Decomposition algorithm - step XF

*/
clear lmi lme var

var sym X(n) F(n,p) sym P(n) S(n,n) sym W(size(B1'*B1))

N = size(Ax,1) / size(Ax,2);
n = size(Ax,2);
m = size(B2x,2);
p = size(C2x,1) / N;

Gg = Lk / Yk;

Akx = zeros(size(Ax));
for i = 1:N
  Akx((i-1)*n+1:i*n,:) = Ax((i-1)*n+1:i*n,:) + B2x((i-1)*n+1:i*n,:) * Gg;
end
Ck = C1 + D12 * Gg;

lmi = block( P;
             P      X;
             B1'*P  B1'*X+D21'*F' W );

for i = 1:N
  lmi = block( -sym(P*Akx((i-1)*n+1:i*n,:));
               - ( Ax((i-1)*n+1:i*n,:)'*P+...
		   X*Akx((i-1)*n+1:i*n,:)+...
		   F*C2x((i-1)*p+1:i*p,:)+S' ),...
                 -sym(X*Ax((i-1)*n+1:i*n,:)+F*C2x((i-1)*p+1:i*p,:));
               -Ck, -C1, eye(size(C1*C1')) );
end

obj = trace(W);

